<script>
    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    import * as d3 from "d3";

    // Default settings
    $: ymaxrow = yScale.domain()[1] - 0.5;
    // console.log(data.datalist);
    let colors = {};
    let row = {};
    if (plot_element.data.dataset == "electron_alerts_metoffice") {
        colors = {
		    ELECTRON_FLUENCE_WARNING_EXTENSION: "orange",
			ELECTRON_FLUENCE_WARNING: "orange",
            ELECTRON_FLUX_2MeV_ALERT_SUMMARY: "blue",
			ELECTRON_FLUX_2MeV_ALERT: "red",
        };
        row = {
            ELECTRON_FLUENCE_WARNING_EXTENSION: 3,
            ELECTRON_FLUENCE_WARNING: 2,
			ELECTRON_FLUX_2MeV_ALERT_SUMMARY: 1,
			ELECTRON_FLUX_2MeV_ALERT: 0,
        };
    } else if (plot_element.data.dataset == "geomagnetic_alerts_metoffice") {
        colors = {
            GEOMAGNETIC_SUDDEN_IMPULSE_ALERT: "red",
			GEOMAGNETIC_SUDDEN_IMPULSE_WARNING: "orange",
			KP_INDEX_ALERT: "red",
			KP_INDEX_WARNING: "orange",
        };
        row = {
            GEOMAGNETIC_SUDDEN_IMPULSE_ALERT: 3,
            GEOMAGNETIC_SUDDEN_IMPULSE_WARNING: 2,
			KP_INDEX_ALERT: 1,
			KP_INDEX_WARNING: 0,
        };
	} else if (plot_element.data.dataset == "proton_alerts_metoffice") {
        colors = {
            PROTON_FLUX_100MeV_ALERT_SUMMARY: "blue",
			PROTON_FLUX_100MeV_ALERT: "red",
			PROTON_FLUX_100MeV_WARNING: "orange",
			PROTON_FLUX_10MeV_ALERT_SUMMARY: "blue",
			PROTON_FLUX_10MeV_ALERT: "red",
			PROTON_FLUX_10MeV_WARNING: "orange",
        };
        row = {
            PROTON_FLUX_100MeV_ALERT_SUMMARY: 5,
            PROTON_FLUX_100MeV_ALERT: 4,
			PROTON_FLUX_100MeV_WARNING: 3,
            PROTON_FLUX_10MeV_ALERT_SUMMARY: 2,
			PROTON_FLUX_10MeV_ALERT: 1,
			PROTON_FLUX_10MeV_WARNING: 0,
        };
    } else if (plot_element.data.dataset == "xray_alerts_metoffice") {
        colors = {
            XRAY_RADIO_BLACKOUT_ALERT_SUMMARY: "blue",
			XRAY_RADIO_BLACKOUT_ALERT: "red",
			XRAY_FLARE_EVENT: "red",
        };
        row = {
            XRAY_RADIO_BLACKOUT_ALERT_SUMMARY: 2,
            XRAY_RADIO_BLACKOUT_ALERT: 1,
			XRAY_FLARE_EVENT: 0,
        };
    } else {
        console.log("This type is not yet implemented");
    }

    const show_notification = function (e) {
        alert(e.srcElement.attributes["data-message"].value);
    };
</script>

{#each data.datalist as d}
    {console.log(d)}
    <g on:click={show_notification}>
        <title>Notification: {d.product_id}</title>
        <circle
            cx={xScale(new Date(d.time))}
            cy={yScale(ymaxrow - row[d.product_id])}
            r="5px"
            fill={colors[d.product_id]}
            data-message="{d.product_id}: {d.message}" />
        {#if d.begin_time.length > 0}
            <line
                x1={xScale(new Date(d.begin_time))}
                x2={xScale(new Date(d.time))}
                y1={yScale(ymaxrow - row[d.product_id])}
                y2={yScale(ymaxrow - row[d.product_id])}
                stroke-width="2px"
                stroke={colors[d.product_id]}
                data-message="{d.product_id}: {d.message}" />
        {/if}
        {#if d.begin_time.length > 0 && d.end_time.length > 0}
            <line
                x1={xScale(new Date(d.begin_time))}
                x2={xScale(new Date(d.end_time))}
                y1={yScale(ymaxrow - row[d.product_id])}
                y2={yScale(ymaxrow - row[d.product_id])}
                stroke-width="6px"
                stroke={colors[d.product_id]}
                data-message="{d.product_id}: {d.message}" />
        {/if}
    </g>
{/each}

<style>
    circle {
        cursor: pointer;
    }
    line {
        cursor: pointer;
    }
</style>
